/* lib/terminal/server/transmission/responder - Send network output, whether an http response or websocket. */ import transmit_http from "./transmit_http.js";
import transmit_ws from "./transmit_ws.js";
const responder = function terminal_server_transmission_responder(data, transmit) {
    if (transmit === null || transmit.socket === null) {
        return;
    }
    if (transmit.type === "http") {
        const serverResponse = transmit.socket;
        transmit_http.respond({
            message: JSON.stringify(data),
            mimeType: "application/json",
            responseType: data.service,
            serverResponse: serverResponse
        }, false, "");
    // account for security of http requests
    } else {
        const socket = transmit.socket;
        transmit_ws.queue(data, socket, 1);
    }
};
export default responder;
