# lib/terminal/commands/library Code Files
The terminal libraries that are available for execution both internally and directly from a shell command. If executed from the shell these libraries will be called from the same named interface file located at [../interface/](../interface).

## Files
<!-- Do not edit below this line.  Contents dynamically populated. -->

* **[agent_data.ts](agent_data.ts)**     - Forms a report of agent data.
* **[agent_online.ts](agent_online.ts)** - A connectivity tester to shared remote agents.
* **[base64.ts](base64.ts)**             - A utility for performing base64 encoding/decoding.
* **[build.ts](build.ts)**               - The library that executes the build and test tasks.
* **[certificate.ts](certificate.ts)**   - A command driven utility for creating an HTTPS certificate.
* **[commands.ts](commands.ts)**         - Utility to list available commands and their respective documentation.
* **[copy.ts](copy.ts)**                 - A command driven utility to perform bit by bit file artifact copy.
* **[directory.ts](directory.ts)**       - A utility to walk the file system and return a data structure.
* **[firewall.ts](firewall.ts)**         - A utility to open firewall settings for this application.
* **[get.ts](get.ts)**                   - A command driven utility to fetch resources from across the internet via HTTP method GET.
* **[hash.ts](hash.ts)**                 - A utility to generate hash sequences on strings or file system artifacts.
* **[lint.ts](lint.ts)**                 - Executes a TypeScript configured form of ESLint from the application's dev dependencies.
* **[mkdir.ts](mkdir.ts)**               - A utility for recursively creating directories in the file system.
* **[remove.ts](remove.ts)**             - A command driven utility to recursively remove file system artifacts.
* **[typescript.ts](typescript.ts)**     - Executes TypeScript type checks.
* **[update.ts](update.ts)**             - A command to update the application from git and then run the build.